https://codeforces.com/problemset/problem/505/C
思路:
开始想着dp,但是dp[3e4][3e4]肯定炸了阿。
但是发现由于最大步长是1+2+3+...a+250 > 30000。所以第二维最多在第一次的d的基础上上下浮动250(其实还没那么多),于是第二维开500就够了。
所以把第二维改成对初始跳跃长度d的偏移量。
偏移量会是减的嘛,所以我们还要加一个类似mod让原点偏移。
让原本的和初始距离d的0偏移量现在变成250的偏移量。那么假如是在d的基础上变小,那么就可以先-250,还是个正数了,这样就不会出现偏移量是负数的问题了。
第二维的值x=250表示和d相等,(x - 250) + d 才是当前跳跃的距离!!
(网上都不是说的很清楚阿0.0
#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cmath>
#include<map>
#include<set>
#include<cstdio>
#include<algorithm>
#define debug(a) cout<<#a<<"="<<a<<endl;
using namespace std;
const int maxn=3e4+1000;
typedef int LL;
inline LL read(){LL x=0,f=1;char ch=getchar(); while (!isdigit(ch)){if (ch=='-') f=-1;ch=getchar();}while (isdigit(ch)){x=x*10+ch-48;ch=getchar();}
return x*f;}
LL dp[maxn][610];
LL a[maxn];
int main(void){
cin.tie(0);std::ios::sync_with_stdio(false);
LL n,d;cin>>n>>d;
for(LL i=1;i<=n;i++){
LL x;cin>>x;
a[x]++;
}
memset(dp,-0x3f,sizeof(dp));
dp[d][250]=a[d];
LL ans=a[d];
for(LL i=1;i<=30000;i++){
for(LL j=1;j<=600;j++){
LL len=j-250+d;
if(i-len>=0){
if(len<=0) continue;
LL mx= max(dp[i-len][j+1],max(dp[i-len][j],dp[i-len][j-1]));
if(mx!=-0x3f3f3f3f){
dp[i][j]=max(dp[i][j],mx+a[i]);
ans=max(ans,dp[i][j]);
}
}
}
}
cout<<ans<<"\n";
return 0;
}